## org.eclipse.emf.ecore.util
Class FeatureMapUtil.BasicFeatureEIterator<E>

    java.lang.Object
      org.eclipse.emf.ecore.util.FeatureMapUtil.BasicFeatureEIterator<E>

All Implemented Interfaces:
  java.util.Iterator<E>, java.util.ListIterator<E>

Direct Known Subclasses:
  BasicFeatureMap.FeatureEIterator, DelegatingFeatureMap.FeatureEIterator

Enclosing class:
  FeatureMapUtil

    public abstract static class FeatureMapUtil.BasicFeatureEIterator<E>

extends java.lang.Object
implements java.util.ListIterator<E>

Field Summary
`protected int` `cursor`
`protected int` `entryCursor`
`protected EStructuralFeature` `eStructuralFeature`
`protected int` `expectedModCount`
`protected FeatureMap.Internal` `featureMap`
`protected boolean` `isFeatureMap`
`protected int` `lastCursor`
`protected int` `prepared`
`protected E` `preparedResult`
`protected FeatureMapUtil.Validator` `validator`

Constructor Summary
`FeatureMapUtil.BasicFeatureEIterator(EStructuralFeature eStructuralFeature, FeatureMap.Internal featureMap)`

Method Summary
`void` `add(java.lang.Object o)`
`protected void` `checkModCount()` Checks that the modification count is as expected.
`protected E` `extractValue(FeatureMap.Entry entry)`
`boolean` `hasNext()`
`boolean` `hasPrevious()`
`E` `next()`
`int` `nextIndex()`
`E` `previous()`
`int` `previousIndex()`
`void` `remove()`
`protected boolean` `resolve()`
`protected abstract boolean` `scanNext()`
`protected abstract boolean` `scanPrevious()`
`void` `set(java.lang.Object o)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### eStructuralFeature

    protected final EStructuralFeature eStructuralFeature

### featureMap

    protected final FeatureMap.Internal featureMap

### entryCursor

    protected int entryCursor

### cursor

    protected int cursor

### prepared

    protected int prepared

### preparedResult

    protected E preparedResult

### expectedModCount

    protected int expectedModCount

### lastCursor

    protected int lastCursor

### isFeatureMap

    protected boolean isFeatureMap

### validator

    protected FeatureMapUtil.Validator validator

Constructor Detail

### FeatureMapUtil.BasicFeatureEIterator

    public FeatureMapUtil.BasicFeatureEIterator(EStructuralFeature eStructuralFeature,
                                                FeatureMap.Internal featureMap)

Method Detail

### resolve

    protected boolean resolve()

### extractValue

    protected E extractValue(FeatureMap.Entry entry)

### hasNext

    public boolean hasNext()

  Specified by:
    `hasNext` in interface `java.util.Iterator<E>`
  Specified by:
    `hasNext` in interface `java.util.ListIterator<E>`

### scanNext

    protected abstract boolean scanNext()

### next

    public E next()

  Specified by:
    `next` in interface `java.util.Iterator<E>`
  Specified by:
    `next` in interface `java.util.ListIterator<E>`

### nextIndex

    public int nextIndex()

  Specified by:
    `nextIndex` in interface `java.util.ListIterator<E>`

### hasPrevious

    public boolean hasPrevious()

  Specified by:
    `hasPrevious` in interface `java.util.ListIterator<E>`

### scanPrevious

    protected abstract boolean scanPrevious()

### previous

    public E previous()

  Specified by:
    `previous` in interface `java.util.ListIterator<E>`

### previousIndex

    public int previousIndex()

  Specified by:
    `previousIndex` in interface `java.util.ListIterator<E>`

### add

    public void add(java.lang.Object o)

  Specified by:
    `add` in interface `java.util.ListIterator<E>`

### remove

    public void remove()

  Specified by:
    `remove` in interface `java.util.Iterator<E>`
  Specified by:
    `remove` in interface `java.util.ListIterator<E>`

### set

    public void set(java.lang.Object o)

  Specified by:
    `set` in interface `java.util.ListIterator<E>`

### checkModCount

    protected void checkModCount()

  Checks that the modification count is as expected.

  Throws:
    `java.util.ConcurrentModificationException` - if the modification count is not as expected.

Copyright 2001-2006 IBM Corporation and others. All Rights Reserved.